# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

Summary:        AspectJ aspect-oriented language extension to Java
Name:           aspectj
Version:        1.2.1
Release:        2jpp_1rh
Epoch:          0
License:        Eclipse Public License
URL:            http://eclipse.org/aspectj/index.html
Group:          Development/Compilers
#Vendor:         JPackage Project
#Distribution:   JPackage
Source0:        aspectj-1.2.1-src.tar.gz
# cvs -d :pserver:anonymous@dev.eclipse.org:/home/technology login 
# cvs -z3 -d :pserver:anonymous@dev.eclipse.org:/home/technology export -r V1_2_1 org.aspectj/modules
Source1:        aspectj-build-build.xml
Source2:        aspectj-jdtcore4aspectj-build.xml
Source3:        bcel-5.1-src.zip
Patch0:         aspectj-1.2.1-bcel-builder-build_xml.patch
Patch1:         aspectj-docs-build_xml.patch
BuildRequires:  jpackage-utils >= 0:1.5, junit
BuildRequires:  ant >= 0:1.6, ant-nodeps >= 0:1.6, ant-junit >= 0:1.6
BuildRequires:  java-1.4.2
BuildRequires:  eclipse-platform
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-logging
BuildRequires:  regexp
BuildRequires:  saxon
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  jakarta-commons-beanutils
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-digester
Requires:  jakarta-commons-logging
Requires:  regexp
Requires:  saxon
Requires:  xalan-j2
Requires:  xerces-j2
Requires:  xml-commons-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
AspectJ is a seamless aspect-oriented language 
extension to Java(tm). It can be used to cleanly 
modularize the crosscutting structure of concerns 
such as exception handling, multi-object protocols, 
synchronization, performance optimizations, and 
resource sharing. When implemented in a 
non-aspect-oriented fashion, the code for these concerns 
typically becomes spread out across entire programs. 
AspectJ controls such code-tangling and makes the 
underlying concerns more apparent, making programs 
easier to develop and maintain. The project goal 
is to support the AspectJ compiler and core tools. 

%package eclipse-plugins
Summary:        Eclipse Plugins for %{name}
Group:          Development/Compilers
Requires:	%{name} = 0:%{version}
Requires:	eclipse-platform

%description eclipse-plugins
%{summary}.

%package installer
Summary:        Installer for %{name}
Group:          Development/Compilers

%description installer
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n org.%{name}
cp %{SOURCE1} modules/build/build-build.xml
cp %{SOURCE1} modules/org.eclipse.jdt.core/build.xml
# save local jdiff sources
export JAVA_HOME=%{_jvmdir}/java
( cd modules/lib/jdiff
  unzip jdiff.jar
  rm jdiff.jar
  rm -rf jdiff
  $JAVA_HOME/bin/javac -d . -sourcepath src `find src -name "*.java"`
  $JAVA_HOME/bin/jar cf jdiff.jar.new jdiff
)
# remove all binary libs
# bundled aspectjrt.jar and aspectjtools.jar are 0 byte, though required
####find . -name "*.jar" -a ! -name "aspectj*.jar" -exec rm {} \;
for j in $(find . -name "*.jar" -a ! -name "aspectj*.jar"); do
	mv $j $j.no
done
# next has been rebuilt from sources
mv modules/lib/jdiff/jdiff.jar.new modules/lib/jdiff/jdiff.jar
# throw 4 jakarta-commons from JPP into one jar
( cd modules/lib/commons
  jar xf $(find-jar commons-beanutils)
  jar xf $(find-jar commons-collections)
  jar xf $(find-jar commons-digester)
  jar xf $(find-jar commons-logging)
  jar cf commons.jar org
)

ln -s $(find-jar junit) modules/lib/junit/junit.jar
ln -s $(find-jar ant) modules/lib/ant/lib/ant.jar
ln -s $(find-jar ant-launcher) modules/lib/ant/lib/ant-launcher.jar
ln -s $(find-jar ant/ant-junit) modules/lib/ant/lib/ant-junit.jar
#ln -s $(find-jar ant/ant-junit) modules/lib/ant/lib/optional.jar
ln -s $(find-jar xalan-j2) modules/lib/ant/lib/xalan.jar
ln -s $(find-jar xerces-j2) modules/lib/ant/lib/xercesImpl.jar
ln -s $(find-jar xml-commons-apis) modules/lib/ant/lib/xml-apis.jar
ln -s $(find-jar regexp) modules/lib/regexp/jakarta-regexp-1.2.jar
ln -s $(find-jar saxon) modules/lib/saxon/saxon.jar

mv modules/build/build-properties.xml modules/build/build-properties.xml.orig
sed -e 's|"DEVELOPMENT"|"1.2.1"|' modules/build/build-properties.xml.orig \
		> modules/build/build-properties.xml

%patch0 -b .sav
%patch1 -b .sav

%build
# CLASSPATH needed for rebuilds from sources
export OPT_JAR_LIST="ant/ant-junit junit ant/ant-nodeps"
export CLASSPATH=$(build-classpath \
ant \
ant-launcher \
commons-beanutils \
commons-collections \
commons-digester \
commons-logging \
regexp \
saxon \
xalan-j2 \
xerces-j2 \
xml-commons-apis \
)

export CLASSPATH=${CLASSPATH}:%{_datadir}/eclipse/plugins/org.eclipse.osgi_3.0.1/core.jar:%{_datadir}/eclipse/plugins/org.eclipse.osgi_3.0.1/osgi.jar:%{_datadir}/eclipse/plugins/org.eclipse.jface.text_3.0.2/jfacetext.jar:%{_datadir}/eclipse/plugins/org.eclipse.text_3.0.1/text.jar:%{_datadir}/eclipse/plugins/org.eclipse.update.configurator_3.0.0/configurator.jar:%{_datadir}/eclipse/plugins/org.eclipse.osgi_3.0.1/eclipseAdaptor.jar

export JAVA_HOME=/usr/lib/jvm/java-1.4.2-sun
# rebuild jdtcore-for-aspectj.jar from sources
pushd modules/org.eclipse.jdt.core
  mkdir src
  cd src
  unzip -q ../jdtcore-for-aspectj-src.zip
  rm -rf javax
  rm -rf org/apache
  rm -rf org/w3c
  rm -rf org/xml
  cd ..
  cp %{SOURCE2} build.xml
export ANT_OPTS="-Xmx256m"
  ant -Dbuild.sysclasspath=first
popd
pushd modules/bcel-builder
cp %{SOURCE3} .
ant extractAndPatchAndJar push
popd
cd modules/build
# rebuild the build-module from sources
ant -f build-build.xml
# do the product build
ant -f build.xml 
# do the release build
cd release
ant install	\
		-Dversion=%{version} -Dskip.cvs=true \
		-Daspectj.modules.dir=../.. \
		-Djava13.home=/usr/lib/jvm/java-1.3.1-sun \
		-Djava14.home=/usr/lib/jvm/java-1.4.2-sun \
		-Drun.14.only=true \
	| tee build-log-release-aspectj-%{version}.txt
# do the test build
ant test	\
		-Dversion=%{version} -Dskip.cvs=true \
		-Daspectj.modules.dir=../.. \
		-Djava13.home=/usr/lib/jvm/java-1.3.1-sun \
		-Djava14.home=/usr/lib/jvm/java-1.4.2-sun \
		-Dskip.build=true \
		-Drun.14.only=true \
	| tee test-log-release-aspectj-%{version}.txt


%install
rm -rf $RPM_BUILD_ROOT
# move manifest.mf to MANIFEST.MF
( cd modules/aj-build/dist/tools/lib
  mkdir tmp
  cd tmp
  jar xf ../aspectjtools.jar
  mv META-INF/manifest.mf META-INF/MANIFEST.MF
  jar cmf META-INF/MANIFEST.MF ../aspectjtools.jar org*
  rm -rf *
  jar xf ../aspectjrt.jar
  mv META-INF/manifest.mf META-INF/MANIFEST.MF
  jar cmf META-INF/MANIFEST.MF ../aspectjrt.jar org*
  rm -rf *
  jar xf ../aspectjweaver.jar
  mv META-INF/manifest.mf META-INF/MANIFEST.MF
  jar cmf META-INF/MANIFEST.MF ../aspectjweaver.jar org*
  cd ..
  rm -rf tmp
)
# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 0644 modules/aj-build/dist/tools/lib/aspectjtools.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}tools-%{version}.jar
install -m 0644 modules/aj-build/dist/tools/lib/aspectjrt.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}rt-%{version}.jar
install -m 0644 modules/aj-build/dist/tools/lib/aspectjweaver.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}weaver-%{version}.jar
install -m 0644 modules/aj-build/dist/aspectj-1.2.1.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}installer-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# plugins
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/eclipse/plugins
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse

install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.ajde
cp -pr modules/aj-build/dist/ide/eclipse/org.aspectj.ajde/* $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.ajde
pushd $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.ajde
rm aspectjrt.jar
ln -sf ../../aspectjrt.jar .
rm aspectjtools.jar
ln -sf ../../aspectjtools.jar .
popd
ln -sf %{_javadir}/aspectj-eclipse/org.aspectj.ajde $RPM_BUILD_ROOT%{_datadir}/eclipse/plugins/org.aspectj.ajde

install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.ajde.doc
cp -pr modules/aj-build/dist/ide/eclipse/org.aspectj.ajde.doc/* $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.ajde.doc
ln -sf %{_javadir}/aspectj-eclipse/org.aspectj.ajde.doc $RPM_BUILD_ROOT%{_datadir}/eclipse/plugins/org.aspectj.ajde.doc

install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.ajde.source
cp -pr modules/aj-build/dist/ide/eclipse/org.aspectj.ajde.source/* $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.ajde.source
ln -sf %{_javadir}/aspectj-eclipse/org.aspectj.ajde.source $RPM_BUILD_ROOT%{_datadir}/eclipse/plugins/org.aspectj.ajde.source

install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.aspectjrt
cp -pr modules/aj-build/dist/ide/eclipse/org.aspectj.aspectjrt/* $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.aspectjrt
pushd $RPM_BUILD_ROOT%{_javadir}/aspectj-eclipse/org.aspectj.aspectjrt
rm aspectjrt.jar
ln -sf ../../aspectjrt.jar .
popd
ln -sf %{_javadir}/aspectj-eclipse/org.aspectj.aspectjrt $RPM_BUILD_ROOT%{_datadir}/eclipse/plugins/org.aspectj.aspecjrt

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr modules/aj-build/dist/docs/doc/api/* \
        $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

rm -rf modules/aj-build/dist/docs/doc/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr modules/aj-build/dist/docs/* \
        $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post eclipse-plugins
rm -f %{_datadir}/eclipse/plugins/org.aspectj.ajde
ln -s %{_javadir}/%{name}-eclipse/org.aspectj.ajde %{_datadir}/eclipse/plugins/org.aspectj.ajde
rm -f %{_datadir}/eclipse/plugins/org.aspectj.ajde.doc
ln -s %{_javadir}/%{name}-eclipse/org.aspectj.ajde.doc %{_datadir}/eclipse/plugins/org.aspectj.ajde.doc
rm -f %{_datadir}/eclipse/plugins/org.aspectj.ajde.source
ln -s %{_javadir}/%{name}-eclipse/org.aspectj.ajde.source %{_datadir}/eclipse/plugins/org.aspectj.ajde.source
rm -f %{_datadir}/eclipse/plugins/org.aspectj.aspectjrt
ln -s %{_javadir}/%{name}-eclipse/org.aspectj.aspectjrt %{_datadir}/eclipse/plugins/org.aspectj.aspectjrt

%postun eclipse-plugins
if [ "$1" = "0" ]; then
  rm -f %{_datadir}/eclipse/plugins/org.aspectj.ajde
  rm -f %{_datadir}/eclipse/plugins/org.aspectj.ajde.doc
  rm -f %{_datadir}/eclipse/plugins/org.aspectj.ajde.source
  rm -f %{_datadir}/eclipse/plugins/org.aspectj.aspectjrt
fi

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/*.html
%{_javadir}/%{name}rt*.jar
%{_javadir}/%{name}tools*.jar
%{_javadir}/%{name}weaver*.jar

%files eclipse-plugins
%defattr(0644,root,root,0755)
%{_javadir}/aspectj-eclipse
%ghost %{_datadir}/eclipse/plugins/*

%files installer
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/*.html
%{_javadir}/%{name}installer*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}


%changelog
* Thu Mar 16 2006 Ben Konrath <bkonrath@redhat.com> - 0:1.2.1-2jpp_1rh
- First Red Hat build
- Don't use build-classpath for the eclipse jars.  

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-2jpp
- First JPP 1.7 build
- Set JAVA_HOME

* Fri Nov 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.1-1jpp
- Upgrade to 1.2.1
- Add eclipse-plugins subpackage
- Add aspectjweaver.jar

* Fri Oct 07 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-4jpp
- Arrange for building with jpackage-utils 1.6.x

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-3jpp
- Build with ant-1.6.2
- Relax some requirement versions

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.1.1-2jpp
- Upgrade to Ant 1.6.X

* Thu Feb 12 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-1jpp
- First JPackage build
